@import '../func/color';
@import '../mixin/spacing';
@import '../mixin/typography';
@import '../variables/theme';

// Headings
h1 {
  font-style: normal;
  font-weight: bold;
  font-size: 36px;

  max-width: 700px;
  margin: 0;
  margin-bottom: 64px;
}

.page-title {
  margin: 0;
  margin-top: 64px;
}

.page-title-article {
  text-align: center;
  margin-left: auto;
  margin-right: auto;
}

h2,
.subtitle {
  font-style: normal;
  font-weight: 600;
  font-size: 24px;

  max-width: 800px;
  margin: 0;
  margin-bottom: 32px;
}

h3 {
  font-style: normal;
  font-weight: bold;
  font-size: 24px;
  line-height: 24px;
  font-variant: small-caps;
  text-transform: lowercase;

  margin: 0;
  margin-bottom: 16px;
}

h4 {
  font-style: normal;
  font-weight: 600;
  font-size: 16px;

  margin: 0;
  margin-bottom: 4px;
}

// Text
p {
  margin-bottom: 16px;
}
p,
li,
figcaption {
  max-width: 70ch;
}
.intro {
  font-weight: 700;
  max-width: 800px;
}
ul {
  margin-top: 0;
}

// Links
a {
  color: var(--accent--dark);
  text-decoration: none;
  word-wrap: break-word;
  overflow-wrap: break-word;

  &:not(.mat-button):not(.mat-raised-button):not(.mat-flat-button):not(.mat-icon-button) {
    transition: color 0.4s, background-color 0.4s, border-color 0.4s;

    &:hover,
    &:active {
      text-decoration: none;
    }
  }

  &.mat-flat-button {
    transition: background-color 0.7s;
    font-weight: 600;
    display: inline-block;
    color: var(--white);

    &:hover,
    &:active {
      text-decoration: none;
      color: var(--white);
      background-color: var(--accent--dim);
    }
  }
}

// Figures
figure {
  margin: 0;
}
figcaption {
  font-size: 12px;
  margin-top: 8px;
  margin-bottom: 8px;
}

// Snippets
pre {
  @include push($space--sm $space--lg);

  line-height: 1.6;
  white-space: pre-wrap;

  background: #f4f4f4;
  border: 1px solid #ddd;
  border-left: 3px solid mat-color($accent);
  color: #666;
  page-break-inside: avoid;
  font-family: monospace;
  font-size: 15px;
  line-height: 1.6;
  margin-bottom: 1.6em;
  max-width: 100%;
  overflow: auto;
  padding: 1em 1.5em;
  display: block;
  word-wrap: break-word;
}

code {
  font-family: $font--console;

  &:not(.highlight) {
    @include soft--right(rem(0.2));

    color: #212529;
    border-radius: rem(0.2);
  }
}

abbr,
abbr[title] {
  text-decoration: none;
}

// Tables
table {
  margin: 0;
  margin-top: 32px;
  margin-bottom: 32px;
  padding: 0;
  thead {
    .special {
      th {
        // border: 2px solid mat-color($accent);
        background-color: #ade7eb;
        color: black;
        font-weight: inherit;
      }
    }
    th {
      background-color: mat-color($accent);
      color: white;
      font-size: 16px;
      text-align: left;
      font-weight: 700;
      height: 32px;
      padding: 16px;
    }
  }
  tbody {
    th,
    td {
      text-align: left;
      padding: 16px;
    }
    tr {
      border: 2px solid white;
      background-color: white;
      &:nth-child(even) {
        background-color: var(--offwhite);
      }
      &:hover {
        background-color: var(--glossy);
      }
    }
  }
}

// Images
img,
iframe {
  max-width: 100%;
  height: auto;
}

